image: ubuntu:20.04

build:
  stage: build
  tags: [ubports]
  script:
    - apt update
    - apt install android-tools-mkbootimg bc bison build-essential ca-certificates cpio curl fakeroot flex git kmod libssl-dev libtinfo5 python2 sudo unzip wget xz-utils -y --no-install-recommends
    - ln -sf python2.7 /usr/bin/python
    - wget https://raw.githubusercontent.com/LineageOS/android_system_core/lineage-17.1/mkbootimg/mkbootimg.py -O /usr/bin/mkbootimg
    - git clone https://gitlab.com/ubports/community-ports/halium-generic-adaptation-build-tools -b halium-11 build
    - ./build.sh
  artifacts:
    paths:
      - out/*

flashable:
  stage: deploy
  script:
    - apt update
    - apt install -y git img2simg jq sudo wget xz-utils
    - git clone https://gitlab.com/ubports/community-ports/halium-generic-adaptation-build-tools -b halium-11 build
    - DEVICE="$(source deviceinfo && echo $deviceinfo_codename)"
    - ./build/fetch-and-prepare-latest-ota.sh "20.04/arm64/android9plus/devel" "$DEVICE" ota
    - mkdir -p out
    - ./build/system-image-from-ota.sh ota/ubuntu_command out
  artifacts:
    paths:
      - out/boot.img
      - out/dtbo.img
      - out/recovery.img
      - out/system.img
  when: manual

devel-flashable:
  stage: deploy
  allow_failure: true
  variables:
    ROOTFS_URL: "https://ci.ubports.com/job/focal-hybris-rootfs-arm64/job/master/lastSuccessfulBuild/artifact/ubuntu-touch-android9plus-rootfs-arm64.tar.gz"
    OTA_CHANNEL: "20.04/arm64/android9plus/devel"
    DEV_TARBALL_VARIANT: _usrmerge
  script:
    - apt update
    - apt install -y git img2simg jq sudo wget xz-utils
    - git clone https://gitlab.com/ubports/community-ports/halium-generic-adaptation-build-tools -b halium-11 build
    - DEVICE="$(source deviceinfo && echo $deviceinfo_codename)"
    - ./build/prepare-fake-ota.sh out/device_${DEVICE}${DEV_TARBALL_VARIANT}.tar.xz ota
    - mkdir -p out
    - ./build/system-image-from-ota.sh ota/ubuntu_command out
  artifacts:
    paths:
      - out/boot.img
      - out/dtbo.img
      - out/recovery.img
      - out/system.img
